; 
    include \masm32\include\masm32rt.inc
    .686
    include timers.asm

    filecmp_heapbuffers       PROTO :DWORD,:DWORD
    filecmp_filemapping       PROTO :DWORD,:DWORD
    filecmp_nobuffering       PROTO :DWORD,:DWORD
    filecmp_nobuffering_async PROTO :DWORD,:DWORD
; 
    .data
      testfile db "\masm32\include\windows.inc",0
    .code
; 
start:
; 
    print "correct return vals: 1 0 0 0 -1 -1 1",13,10
    print "filecmp_heapbuffers: "
    invoke filecmp_heapbuffers, chr$("file1.txt"),chr$("file1.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers, chr$("file1.txt"),chr$("file2.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers, chr$("file1.txt"),chr$("file3.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers, chr$("file1.txt"),chr$("file4.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers, chr$("file1.txt"),chr$("filex.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers, chr$("filex.txt"),chr$("file1.txt")
    print str$(eax)," "
    invoke filecmp_heapbuffers,ADDR testfile,ADDR testfile
    print str$(eax),13,10
    print "filecmp_filemapping: "
    invoke filecmp_filemapping, chr$("file1.txt"),chr$("file1.txt")
    print str$(eax)," "
    invoke filecmp_filemapping, chr$("file1.txt"),chr$("file2.txt")
    print str$(eax)," "
    invoke filecmp_filemapping, chr$("file1.txt"),chr$("file3.txt")
    print str$(eax)," "
    invoke filecmp_filemapping, chr$("file1.txt"),chr$("file4.txt")
    print str$(eax)," "
    invoke filecmp_filemapping, chr$("file1.txt"),chr$("filex.txt")
    print str$(eax)," "
    invoke filecmp_filemapping, chr$("filex.txt"),chr$("file1.txt")
    print str$(eax)," "
    invoke filecmp_filemapping,ADDR testfile,ADDR testfile
    print str$(eax),13,10,13,10

    print "filecmp_nobuffering: x x x x  x  x "
    invoke filecmp_nobuffering,ADDR testfile,ADDR testfile

    print str$(eax),13,10,13,10

    print "filecmp_nobuffering_async: x x x x  x  x "
    invoke filecmp_nobuffering_async,ADDR testfile,ADDR testfile
    print str$(eax),13,10,13,10

    ;;inkey "Press any key to exit..."
    ;;exit

    LOOP_COUNT equ 100
    print "filecmp_heapbuffers: "
    timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke filecmp_heapbuffers,ADDR testfile,ADDR testfile
    timer_end
    push eax    
    print ustr$(eax),"ms",13,10

    print "filecmp_filemapping: "
    timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke filecmp_filemapping,ADDR testfile,ADDR testfile
    timer_end
    push eax
    print ustr$(eax),"ms",13,10,13,10

    fild DWORD PTR[esp]
    fild DWORD PTR[esp+4]
    fdiv
    fld8 100.0
    fmul
    fstp QWORD PTR[esp]
    pop eax
    pop edx

    invoke crt_printf,chr$("%.1f%%%c%c"),edx::eax,10,10

    invoke Sleep,1000

    print "filecmp_nobuffering: "
    timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke filecmp_nobuffering,ADDR testfile,ADDR testfile
    timer_end
    push eax
    print ustr$(eax),"ms",13,10,13,10

    invoke Sleep,1000

    print "filecmp_nobuffering_async: "
    timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke filecmp_nobuffering_async,ADDR testfile,ADDR testfile
    timer_end
    push eax
    print ustr$(eax),"ms",13,10,13,10

    inkey "Press any key to exit..."
    exit

; 
; This proc performs a binary comparison of two files, returning 0
; if the files are different, 1 if the files are byte identical, or
; INVALID_HANDLE_VALUE (-1) if there is a problem opening either
; of the files.
; 

filecmp_heapbuffers proc uses ebx lpszFile1:DWORD, lpszFile2:DWORD

    LOCAL hFile1:DWORD,lof1:DWORD,lpMem1:DWORD
    LOCAL hFile2:DWORD,lof2:DWORD,lpMem2:DWORD
    LOCAL bytesRead:DWORD

    invoke CreateFile,lpszFile1,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFile1, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    ret

  @@:
    invoke CreateFile,lpszFile2,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFile2, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    push eax
    invoke CloseHandle,hFile1
    pop eax
    ret

  @@:
    invoke GetFileSize,hFile1,NULL
    mov lof1, eax
    invoke GetFileSize,hFile2,NULL
    mov lof2, eax

    xor ebx, ebx
    mov ecx, lof1
    cmp ecx, lof2
    jne @F

    invoke GetProcessHeap
    push eax
    invoke HeapAlloc,eax,0,lof1
    mov lpMem1, eax
    pop eax
    invoke HeapAlloc,eax,0,lof1
    mov lpMem2, eax

    invoke ReadFile,hFile1,lpMem1,lof1,ADDR bytesRead,NULL
    invoke ReadFile,hFile2,lpMem2,lof1,ADDR bytesRead,NULL

    invoke cmpmem,lpMem1,lpMem2,lof1
    mov ebx, eax

    invoke GetProcessHeap
    push eax
    invoke HeapFree,eax,0,lpMem1
    pop eax
    invoke HeapFree,eax,0,lpMem2

  @@:
    invoke CloseHandle,hFile1
    invoke CloseHandle,hFile2

    mov eax, ebx
    ret

filecmp_heapbuffers endp

; 
; This proc performs a binary comparison of two files, returning
; 0 if the files are different, 1 if the files are byte identical,
; or INVALID_HANDLE_VALUE (-1) if there is a problem opening
; either of the files.
; 
filecmp_filemapping proc uses ebx lpszFile1:DWORD, lpszFile2:DWORD

    LOCAL hFile1:DWORD,lof1:DWORD,hMMF1:DWORD,lpMem1:DWORD
    LOCAL hFile2:DWORD,lof2:DWORD,hMMF2:DWORD,lpMem2:DWORD

    invoke CreateFile,lpszFile1,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFile1, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    ret

  @@:
    invoke CreateFile,lpszFile2,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFile2, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    push eax
    invoke CloseHandle,hFile1
    pop eax
    ret

  @@:
    invoke GetFileSize,hFile1,NULL
    mov lof1, eax
    invoke GetFileSize,hFile2,NULL
    mov lof2, eax

    xor ebx, ebx
    mov ecx, lof1
    cmp ecx, lof2
    jne @F

    mov hMMF1, rv(CreateFileMapping,hFile1,NULL,PAGE_READWRITE,0,0,NULL)
    mov lpMem1, rv(MapViewOfFile,hMMF1,FILE_MAP_WRITE,0,0,0)
    mov hMMF2, rv(CreateFileMapping,hFile2,NULL,PAGE_READWRITE,0,0,NULL)
    mov lpMem2, rv(MapViewOfFile,hMMF2,FILE_MAP_WRITE,0,0,0)

    invoke cmpmem,lpMem1,lpMem2,lof1
    mov ebx, eax

    invoke UnmapViewOfFile,lpMem1
    invoke UnmapViewOfFile,lpMem2
    invoke CloseHandle,hMMF1
    invoke CloseHandle,hMMF2

  @@:    
    invoke CloseHandle,hFile1
    invoke CloseHandle,hFile2

    mov eax, ebx
    ret

filecmp_filemapping endp

; 

filecmp_nobuffering proc uses ebx lpszFile1:DWORD, lpszFile2:DWORD

    LOCAL hFile1:DWORD,lof1:DWORD,memBase1:DWORD,lpMem1:DWORD
    LOCAL hFile2:DWORD,lof2:DWORD,memBase2:DWORD,lpMem2:DWORD
    LOCAL bytesRead:DWORD,bytesPerSector:DWORD

    invoke CreateFile,lpszFile1,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL or FILE_FLAG_NO_BUFFERING,
                      NULL
    mov hFile1, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    ret

  @@:
    invoke CreateFile,lpszFile2,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL or FILE_FLAG_NO_BUFFERING,
                      NULL
    mov hFile2, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    push eax
    invoke CloseHandle,hFile1
    pop eax
    ret

  @@:
    invoke GetDiskFreeSpace,NULL,
                            ADDR bytesRead,
                            ADDR bytesPerSector,
                            ADDR bytesRead,
                            ADDR bytesRead

    ; Determine truncation shift

    mov eax, bytesPerSector
    xor ebx, ebx
  @@:
    shr eax, 1
    jc  @F
    add ebx, 1
    cmp ebx, 32
    jb  @B
  @@:

    ;;print ustr$(ebx)," truncation shift",13,10

    ; Get file size and truncate to multiple of sector size

    invoke GetFileSize,hFile1,NULL
    ;;push eax
    ;;print uhex$(eax)," filesize",13,10
    ;;pop eax
    mov ecx, ebx
    shr eax, cl
    shl eax, cl
    mov lof1, eax
    ;;print uhex$(eax)," truncated size",13,10
    invoke GetFileSize,hFile2,NULL
    mov ecx, ebx
    shr eax, cl
    shl eax, cl
    mov lof2, eax
    ;;print uhex$(eax)," truncated size",13,10

    xor ebx, ebx
    mov ecx, lof1
    cmp ecx, lof2
    jne @F

    ; Allocate memory and calc sector-aligned start address

    mov ebx, lof1
    add ebx, bytesPerSector
    invoke GetProcessHeap
    push eax
    invoke HeapAlloc,eax,0,ebx
    mov memBase1, eax
    mov ecx, bytesPerSector
    sub ecx, 1
    add eax, ecx
    add ecx, 1
    neg ecx
    and eax, ecx
    mov lpMem1, eax
    pop eax
    invoke HeapAlloc,eax,0,ebx
    mov memBase2, eax
    mov ecx, bytesPerSector
    sub ecx, 1
    add eax, ecx
    add ecx, 1
    neg ecx
    and eax, ecx
    mov lpMem2, eax

    ;;print uhex$(memBase1)," memBase1",13,10
    ;;print uhex$(lpMem1)," lpMem1",13,10
    ;;print uhex$(memBase2)," memBase2",13,10
    ;;print uhex$(lpMem2)," lpMem2",13,10
    ;;print uhex$(lof1)," read size",13,10

    invoke ReadFile,hFile1,lpMem1,lof1,ADDR bytesRead,NULL
    invoke ReadFile,hFile2,lpMem2,lof1,ADDR bytesRead,NULL

    invoke cmpmem,lpMem1,lpMem2,lof1
    mov ebx, eax

    invoke GetProcessHeap
    push eax
    invoke HeapFree,eax,0,lpMem1
    pop eax
    invoke HeapFree,eax,0,lpMem2

  @@:
    invoke CloseHandle,hFile1
    invoke CloseHandle,hFile2

    mov eax, ebx
    ret

filecmp_nobuffering endp

; 

filecmp_nobuffering_async proc uses ebx lpszFile1:DWORD, lpszFile2:DWORD

    LOCAL hFile1:DWORD,lof1:DWORD,memBase1:DWORD,lpMem1:DWORD
    LOCAL hFile2:DWORD,lof2:DWORD,memBase2:DWORD,lpMem2:DWORD
    LOCAL bytesRead:DWORD,bytesPerSector:DWORD

    LOCAL hEvent1:DWORD, hEvent2:DWORD
    LOCAL overlapped1:OVERLAPPED
    LOCAL overlapped2:OVERLAPPED

    invoke CreateFile,lpszFile1,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL or FILE_FLAG_NO_BUFFERING or FILE_FLAG_OVERLAPPED,
                      NULL
    mov hFile1, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    ret

  @@:
    invoke CreateFile,lpszFile2,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL or FILE_FLAG_NO_BUFFERING or FILE_FLAG_OVERLAPPED,
                      NULL
    mov hFile2, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    push eax
    invoke CloseHandle,hFile1
    pop eax
    ret

  @@:
    invoke GetDiskFreeSpace,NULL,
                            ADDR bytesRead,
                            ADDR bytesPerSector,
                            ADDR bytesRead,
                            ADDR bytesRead

    ; Determine truncation shift

    mov eax, bytesPerSector
    xor ebx, ebx
  @@:
    shr eax, 1
    jc  @F
    add ebx, 1
    cmp ebx, 32
    jb  @B
  @@:
    ;;print ustr$(ebx)," truncation shift",13,10

    ; Get file size and truncate to multiple of sector size

    invoke GetFileSize,hFile1,NULL
    ;;push eax
    ;;print uhex$(eax)," filesize",13,10
    ;;pop eax
    mov ecx, ebx
    shr eax, cl
    shl eax, cl
    mov lof1, eax
    ;;print uhex$(eax)," truncated size",13,10
    invoke GetFileSize,hFile2,NULL
    mov ecx, ebx
    shr eax, cl
    shl eax, cl
    mov lof2, eax
    ;;print uhex$(eax)," truncated size",13,10

    xor ebx, ebx
    mov ecx, lof1
    cmp ecx, lof2
    jne @F

    ; Allocate memory and calc sector-aligned start address

    mov ebx, lof1
    add ebx, bytesPerSector
    invoke GetProcessHeap
    push eax
    invoke HeapAlloc,eax,0,ebx
    mov memBase1, eax
    mov ecx, bytesPerSector
    sub ecx, 1
    add eax, ecx
    add ecx, 1
    neg ecx
    and eax, ecx
    mov lpMem1, eax
    pop eax
    invoke HeapAlloc,eax,0,ebx
    mov memBase2, eax
    mov ecx, bytesPerSector
    sub ecx, 1
    add eax, ecx
    add ecx, 1
    neg ecx
    and eax, ecx
    mov lpMem2, eax

    ;;print uhex$(memBase1)," memBase1",13,10
    ;;print uhex$(lpMem1)," lpMem1",13,10
    ;;print uhex$(memBase2)," memBase2",13,10
    ;;print uhex$(lpMem2)," lpMem2",13,10

    mov hEvent1, rv(CreateEvent,NULL,FALSE,FALSE,NULL)
    ;;print ustr$(eax)," rv CreateEvent",13,10
    mov hEvent2, rv(CreateEvent,NULL,FALSE,FALSE,NULL)
    ;;print ustr$(eax)," rv CreateEvent",13,10

    mov overlapped1.loffset, 0
    mov overlapped1.OffsetHigh, 0
    mov eax, hEvent1
    mov overlapped1.hEvent, eax
    mov overlapped2.loffset, 0
    mov overlapped2.OffsetHigh, 0
    mov eax, hEvent2
    mov overlapped2.hEvent, eax

    ;;print uhex$(lof1)," read size",13,10

    ;;ERROR_IO_PENDING = 997
    invoke ReadFile,hFile1,lpMem1,lof1,ADDR bytesRead,ADDR overlapped1
    ;;call GetLastError
    ;;print ustr$(eax)," rv ReadFile",13,10
    invoke ReadFile,hFile2,lpMem2,lof1,ADDR bytesRead,ADDR overlapped2
    ;;call GetLastError
    ;;print ustr$(eax)," rv ReadFile",13,10

    ;;WAIT_FAILED = -1
    invoke WaitForMultipleObjects,2,ADDR hEvent2,TRUE,10000
    ;;call GetLastError
    ;;print hex$(eax)," rv WaitForMultipleObjects",13,10

    ;;invoke FlushFileBuffers,hFile1
    ;;invoke FlushFileBuffers,hFile2

    invoke cmpmem,lpMem1,lpMem2,lof1
    mov ebx, eax

    invoke GetProcessHeap
    push eax
    invoke HeapFree,eax,0,lpMem1
    pop eax
    invoke HeapFree,eax,0,lpMem2

  @@:
    invoke CloseHandle,hFile1
    invoke CloseHandle,hFile2

    mov eax, ebx
    ret

filecmp_nobuffering_async endp

; 
end start

OVERLAPPED STRUCT
  Internal      DWORD      ?
  InternalHigh  DWORD      ?
  loffset       DWORD      ?
  OffsetHigh    DWORD      ?
  hEvent        DWORD      ?
OVERLAPPED ENDS